﻿// For an introduction to the Page Control template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232511
(function () {
    "use strict";

    function show(message) {
        new Windows.UI.Popups.MessageDialog(message).showAsync();
    }

    WinJS.UI.Pages.define("/controls.html", {
        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {
            // TODO: Initialize the page here.
            attachEvents();
        },

        unload: function () {
            // TODO: Respond to navigations away from this page.
        },

        updateLayout: function (element, viewState, lastViewState) {
            /// <param name="element" domElement="true" />

            // TODO: Respond to changes in viewState.
            
        }
    });

    function attachEvents() {
        back.addEventListener("click", function () {
            window.history.back();
        });

        theSwitch.winControl.addEventListener('change', function (e) {
            var isChecked = e.currentTarget.winControl.checked;

            show('Hai selezionato ' + isChecked);
        });

        datePicker.winControl.addEventListener('change', handleChange);
        timePicker.winControl.addEventListener('change', handleChange);

        rating.winControl.addEventListener('previewchange', function (eventInfo) {
            var newValue = rating.winControl.tooltipStrings[eventInfo.detail.tentativeRating - 1];

            ratingSpan.innerHTML = newValue;
        });

        menuLabel.addEventListener('contextmenu', showMenu);

        btnFlyOut.addEventListener('click', function () {
            theFlyOut.winControl.show(btnFlyOut);
        });
    }

    function handleChange(e) {
        var result = datePicker.winControl.current;
        result.setHours(timePicker.winControl.current.getHours());
        result.setMinutes(timePicker.winControl.current.getMinutes());
        
        show('Hai selezionato ' + result.toLocaleString());
    }

    function showMenu(e) {
        
        var menu = new Windows.UI.Popups.PopupMenu();
        menu.commands.append(new Windows.UI.Popups.UICommand("Opzione 1", handleCommand));
        menu.commands.append(new Windows.UI.Popups.UICommand("Opzione 2", handleCommand));
        menu.commands.append(new Windows.UI.Popups.UICommandSeparator());
        menu.commands.append(new Windows.UI.Popups.UICommand("Opzione 3", handleCommand));

        menu.showAsync({ x: e.pageX, y: e.pageY });
    }

    function handleCommand(e) {
        show('Hai selezionato ' + e.label);
    }

})();
