﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
	"use strict";

	WinJS.Binding.optimizeBindingReferences = true;

	var app = WinJS.Application;
	var activation = Windows.ApplicationModel.Activation;

	app.onactivated = function (args) {
		if (args.detail.kind === activation.ActivationKind.launch) {
			if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
				// TODO: This application has been newly launched. Initialize
				// your application here.
			} else {
				// TODO: This application has been reactivated from suspension.
				// Restore application state here.
			}

			// sottoscrizione al contratto
			var printManager = Windows.Graphics.Printing.PrintManager.getForCurrentView();
			printManager.onprinttaskrequested = onPrintTaskRequested;

			args.setPromise(WinJS.UI.processAll());
		}
	};

	function onPrintTaskRequested(printEvent) {
		var printTask = printEvent.request.createPrintTask("Esempio di stampa", function (args) {
			// impostiamo la sorgente
			args.setSource(MSApp.getHtmlPrintDocumentSource(document));

			// opzioni di stampa
			printTask.options.displayedOptions.clear();
			printTask.options.displayedOptions.append(Windows.Graphics.Printing.StandardPrintTaskOptions.copies);
			printTask.options.displayedOptions.append(Windows.Graphics.Printing.StandardPrintTaskOptions.orientation);
			printTask.options.displayedOptions.append(Windows.Graphics.Printing.StandardPrintTaskOptions.mediaSize);
			printTask.options.displayedOptions.append(Windows.Graphics.Printing.StandardPrintTaskOptions.collation);
			printTask.options.displayedOptions.append(Windows.Graphics.Printing.StandardPrintTaskOptions.duplex);

			// valori predefiniti
			printTask.options.mediaSize = Windows.Graphics.Printing.PrintMediaSize.northAmericaLegal;



			// aspettiamo che la stampa sia completa
			printTask.oncompleted = onPrintTaskCompleted;
		});
	}

	function onPrintTaskCompleted(printTaskCompletionEvent) {
		if (printTaskCompletionEvent.completion === Windows.Graphics.Printing.PrintTaskCompletion.failed) {
			alert('Impossibile stampare!');
		}
	}



	app.onunload = function () {
		// deregistriamo l'evento
		var printManager = Windows.Graphics.Printing.PrintManager.getForCurrentView();
		printManager.onprinttaskrequested = null;
	}

	app.oncheckpoint = function (args) {
		// TODO: This application is about to be suspended. Save any state
		// that needs to persist across suspensions here. You might use the
		// WinJS.Application.sessionState object, which is automatically
		// saved and restored across suspension. If you need to complete an
		// asynchronous operation before your application is suspended, call
		// args.setPromise().
	};

	app.start();
})();
