﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
	"use strict";

	WinJS.Binding.optimizeBindingReferences = true;

	var app = WinJS.Application;
	var activation = Windows.ApplicationModel.Activation;
	var shareOperation = null;

	app.onactivated = function (args) {
		if (args.detail.kind === activation.ActivationKind.launch) {
			if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
				// TODO: This application has been newly launched. Initialize
				// your application here.
			} else {
				// TODO: This application has been reactivated from suspension.
				// Restore application state here.
			}
			args.setPromise(WinJS.UI.processAll());
		}

		else if (args.detail.kind === activation.ActivationKind.shareTarget) {
			// facciamo proseguire l'attivazione
			args.setPromise(WinJS.UI.processAll());

			// salviamo le informazioni
			shareOperation = args.detail.shareOperation;

			// richiediamo l'accodamento di un evento asincrono
			// per non bloccare l'attivazione
			WinJS.Application.addEventListener("onshareready", shareReady, false);
			WinJS.Application.queueEvent({ type: "onshareready" });
		}
	};

	function shareReady(args) {
		if (shareOperation.data.contains(Windows.ApplicationModel.DataTransfer.StandardDataFormats.text)) {

			shareOperation.data.getTextAsync().done(function (value) {
				document.getElementById("results").innerText = value;
			});

			var quickLink = new Windows.ApplicationModel.DataTransfer.ShareTarget.QuickLink();
			quickLink.id = "12334";
			quickLink.title = "Esempio di quicklink";
			quickLink.supportedFileTypes.replaceAll(["*"]);
			quickLink.supportedDataFormats.replaceAll([Windows.ApplicationModel.DataTransfer.StandardDataFormats.text]);

			Windows.ApplicationModel.Package.current.installedLocation.getFileAsync("Assets\\Logo.png").then(function (iconFile) {
				quickLink.thumbnail = Windows.Storage.Streams.RandomAccessStreamReference.createFromFile(iconFile);
				shareOperation.reportCompleted(quickLink);
			});
		}
		else
			shareOperation.ReportError("Niente da condividere");
	}


	app.oncheckpoint = function (args) {
		// TODO: This application is about to be suspended. Save any state
		// that needs to persist across suspensions here. You might use the
		// WinJS.Application.sessionState object, which is automatically
		// saved and restored across suspension. If you need to complete an
		// asynchronous operation before your application is suspended, call
		// args.setPromise().
	};

	app.start();
})();
