﻿// For an introduction to the Grid template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkID=232446
(function () {
    "use strict";

    WinJS.Binding.optimizeBindingReferences = true;

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;
    var nav = WinJS.Navigation;

    app.addEventListener("activated", function (args) {
        var fromProtocol = (args.detail.kind === activation.ActivationKind.protocol);
        var fromFile = (args.detail.kind === activation.ActivationKind.file);

        if (args.detail.kind === activation.ActivationKind.launch || fromProtocol || fromFile) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: This application has been newly launched. Initialize
                // your application here.
            } else {
                // TODO: This application has been reactivated from suspension.
                // Restore application state here.
            }

            if (app.sessionState.history) {
                nav.history = app.sessionState.history;
            }

            args.setPromise(WinJS.UI.processAll().then(function () {

                if (fromProtocol) {
                    // Divido group1-Item Title: 1
                    var item = args.detail.uri.host.split("-");
                    // Navigo nel dettaglio
                    nav.navigate("/pages/itemDetail/itemDetail.html", { item: item});
                }
                else if (fromFile) {
                    Windows.Storage.FileIO.readTextAsync(args.detail.files[0]).then(function (text) {
                        // Divido group1-Item Title: 1
                        var item = text.split("-");
                        // Navigo nel dettaglio
                        nav.navigate("/pages/itemDetail/itemDetail.html", { item: item});
                    });
                }

                // Presente già nel template
                else if (nav.location) {
                    nav.history.current.initialPlaceholder = true;
                    return nav.navigate(nav.location, nav.state);
                } else {
                    return nav.navigate(Application.navigator.home);
                }                
            }));
        }        
    });

    app.oncheckpoint = function (args) {
        // Già presente con il template pre
        app.sessionState.history = nav.history;

        // Ottengo la pagina corrente
        var currentPage = Application.navigator.pageControl;
        var currentCheckpoint = currentPage.checkpoint;
        // Chiamo la funzione solo se c'è
        if (currentCheckpoint) {
            currentCheckpoint.bind(currentPage)();
        }
    };

    app.start();
})();
