﻿(function () {
    "use strict";

    WinJS.UI.Pages.define("/pages/itemDetail/itemDetail.html", {

        _items: null,
        _options: null,

        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {
            this._options = options;

            var item = options && options.item ? Data.resolveItemReference(options.item) : Data.items.getAt(0);
            element.querySelector(".titlearea .pagetitle").textContent = item.group.title;

            this._items = Data.getItemsFromGroup(item.group);
            var flipView = document.getElementById("flipView").winControl;
            // Imposto la sorgente dati
            flipView.itemDataSource = this._items.dataSource;
            // Seleziono l'indice dell'elemento
            flipView.currentPage = this._items.indexOf(item);

            element.querySelector(".content").focus();

            if (options.altro) {
            }
        },
        checkpoint: function () {
            var flipView = document.getElementById("flipView").winControl;
            // Ottengo l'elemento dall'indice del flipView
            var item = this._items.getItem(flipView.currentPage);
            // Sostituisco l'item con quello dell'elemento
            // corrente del flipView
            this._options.item = Data.getItemReference(item.data);

            this._options.altro = 2;
        },
        unload: function () {
            this.checkpoint();
        }
    });
})();
