﻿// For an introduction to the Page Control template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232511
(function () {
    "use strict";

    var playTo = Windows.Media.PlayTo;
    var storage = Windows.Storage;

    WinJS.UI.Pages.define("/pages/playTo/playTo.html", {
        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {

            this.sourcerequestedHandler = this.sourcerequested.bind(this);

            // Intercetto l'evento di richiesta sorgente
            playTo.PlayToManager.getForCurrentView().addEventListener("sourcerequested", this.sourcerequestedHandler);

            this.loadFolder(storage.KnownFolders.mediaServerDevices);
        },

        sourcerequested: function (s, e) {
            
            // In base alla visibilità dell'immagine o del video
            // decido cosa usare come sorgente
            if (image.style.display != "none")
                e.sourceRequest.setSource(image.msPlayToSource);
            else if (video.style.display != "none")
                e.sourceRequest.setSource(video.msPlayToSource);
        },

        loadFolder: function (folder) {
            var self = this;
            var foldersPromise = folder.getFoldersAsync();
            var filesPromise = folder.getFilesAsync();

            WinJS.Promise.join([foldersPromise, filesPromise]).then(function (r) {
                var list = new WinJS.Binding.List();
                if (r[0].length > 0)
                    list.push(r[0]);
                if (r[1].length > 0)
                    list.push(r[1]);

                document.getElementById("listView").winControl.itemDataSource = list.dataSource;
            });
        },

        unload: function () {
            Windows.Media.PlayTo.PlayToManager.getForCurrentView().removeEventListener("sourcerequested", this.sourcerequestedHandler);
        },

        updateLayout: function (element, viewState, lastViewState) {
            /// <param name="element" domElement="true" />

            // TODO: Respond to changes in viewState.
        }
    });
})();
