﻿// For an introduction to the Page Control template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232511
(function () {
    "use strict";

    WinJS.UI.Pages.define("/pages/uiCapture/uiCapture.html", {
        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {
            document.getElementById("button").addEventListener("click", function () {
                image.src = "";
                video.src = "";
                image.style.display = "none";
                video.style.display = "none";

                var capture = Windows.Media.Capture;

                // Oggetto per catturare
                var ui = new capture.CameraCaptureUI();

                // Impostazioni della foto
                ui.photoSettings.format = capture.CameraCaptureUIPhotoFormat.Jpeg;
                ui.photoSettings.allowCropping = true;
                ui.photoSettings.croppedAspectRatio = { width: 16, height: 9 };
            
                // Impostazioni del video
                ui.videoSettings.format = capture.CameraCaptureUIVideoFormat.Mp4;
                ui.videoSettings.maxDurationInSeconds = 10;
                ui.videoSettings.allowTrimming = true;

                // Apre la UI per catturare dalla camera
                ui.captureFileAsync(capture.CameraCaptureUIMode.PhotoOrVideo).then(function (file) {
                    var uri = "ms-appdata:///temp/" + file.name;
                    var element;
                    // Decido se è un'immagine o un video
                    switch (file.contentType)
                    {
                        case "image/jpeg":
                            element = image;
                            break;
                        case "video/mp4":
                            element = video;
                            break;
                    }
                    // Imposto l'uri sull'elemento
                    element.src = uri;
                    element.style.display = "block";
                });
            });
        },

        unload: function () {
            // TODO: Respond to navigations away from this page.
        },

        updateLayout: function (element, viewState, lastViewState) {
            /// <param name="element" domElement="true" />

            // TODO: Respond to changes in viewState.
        }
    });
})();
