﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    WinJS.Binding.optimizeBindingReferences = true;

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                attachEvents();

                if (args.detail.tileId == SECONDARY_TILE)
                {
                    // applicazione eseguita tramite tile secondaria, leggo
                    // gli arguments della tile, se necessario
                    var tile = args.detail.arguments;
                }
                

            } else {
                // TODO: This application has been reactivated from suspension.
                // Restore application state here.
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. You might use the
        // WinJS.Application.sessionState object, which is automatically
        // saved and restored across suspension. If you need to complete an
        // asynchronous operation before your application is suspended, call
        // args.setPromise().
    };

    function attachEvents() {
        btnPlaceSecondTile.addEventListener("click", placeSecondTile);
        btnRemoveSecondTile.addEventListener("click", removeSecondTile);
        btnPlaceTile.addEventListener("click", placeTile);
        btnClearTile.addEventListener("click", clearTile);
        btnNotifySecondaryTile.addEventListener("click", notifySecondaryTile);
        btnNotificationQueue.addEventListener("click", notificationQueue);
        btnPlaceBadge.addEventListener("click", placeBadge);
        btnShowToast.addEventListener("click", showToast);
        btnScheduleToast.addEventListener("click", scheduleToast);
        btnRequestChannel.addEventListener("click", requestChannel);
    }

    var SECONDARY_TILE = "SecondaryTile";
    function placeSecondTile() {
        var tile = new Windows.UI.StartScreen.SecondaryTile(SECONDARY_TILE);
        tile.shortName = "Tile secondaria";
        tile.displayName = "Un esempio di tile secondaria";
        tile.wideLogo = new Windows.Foundation.Uri('ms-appx:///images/SecondaryLogo.png');
        tile.logo = new Windows.Foundation.Uri('ms-appx:///images/Logo.png');
        tile.tileOptions = Windows.UI.StartScreen.TileOptions.showNameOnWideLogo;
        tile.arguments = "Esempio";

        var clientRect = btnPlaceSecondTile.getBoundingClientRect();
        var rect = { x: clientRect.left, y: clientRect.top, width: clientRect.width, height: clientRect.height };

        tile.requestCreateForSelectionAsync(rect).done(function(isPinned) {
            if (isPinned) {
                Windows.UI.Popups.MessageDialog("Creazione completata").showAsync();
            } else {
                Windows.UI.Popups.MessageDialog("Creazione annullata").showAsync();
            }
        });
    }

    function removeSecondTile() {
        var tile = new Windows.UI.StartScreen.SecondaryTile(SECONDARY_TILE);

        var clientRect = btnRemoveSecondTile.getBoundingClientRect();
        var rect = { x: clientRect.left, y: clientRect.top, width: clientRect.width, height: clientRect.height };

        tile.requestDeleteForSelectionAsync(rect).done(function (isUnpinned) {
            if (isUnpinned) {
                Windows.UI.Popups.MessageDialog("Rimozione completata con successo").showAsync();
            } else {
                Windows.UI.Popups.MessageDialog("Rimozione annullata").showAsync();
            }
        });
    }

    var winNotify = Windows.UI.Notifications;
    function placeTileOld() {
        var document = winNotify.TileUpdateManager.getTemplateContent(
            winNotify.TileTemplateType.tileSquareText01);

        var textNodes = document.getElementsByTagName("text");
        for (var index = 0; index < textNodes.length; index++) {
            textNodes[index].innerText = "Linea " + index;
        }

        var notification = new winNotify.TileNotification(document);

        var currentTime = new Date();
        notification.expirationTime = new Date(currentTime.getTime() + (60 * 1000));

        winNotify.TileUpdateManager.createTileUpdaterForApplication().update(notification);
    }

    function clearTile() {
        winNotify.TileUpdateManager
            .createTileUpdaterForApplication().clear();
    }

    function notifySecondaryTile() {
        var tileExists = Windows.UI.StartScreen.SecondaryTile.exists(SECONDARY_TILE);
        if (!tileExists)
            return;

        var document = winNotify.TileUpdateManager.getTemplateContent(
            winNotify.TileTemplateType.tileWideText01);

        var textNodes = document.getElementsByTagName("text");
        for (var index = 0; index < textNodes.length; index++) {
            textNodes[index].innerText = "Linea " + index;
        }

        var notification = new winNotify.TileNotification(document);

        var currentTime = new Date();
        notification.expirationTime = new Date(currentTime.getTime() + (60 * 1000));

        winNotify.TileUpdateManager
            .createTileUpdaterForSecondaryTile(SECONDARY_TILE)
            .update(notification);
    }

    var tileContentFactory = NotificationsExtensions.TileContent.TileContentFactory;
    function placeTile() {
        var wideTile = tileContentFactory.createTileWideImageAndText01();
        wideTile.textCaptionWrap.text = "Windows 8 is awesome";
        wideTile.image.src = "http://gui.aspitalia.com/images/aspitalia/aspitalia.png";

        var squareTile = tileContentFactory.createTileSquarePeekImageAndText03();
        squareTile.image.src = "images/Windows-8-logo.jpg";
        squareTile.textBody1.text = "Windows 8 is";
        squareTile.textBody2.text = "awesome!!";

        wideTile.squareContent = squareTile;

        var notification = wideTile.createNotification();

        var currentTime = new Date();
        notification.expirationTime = new Date(currentTime.getTime() + (60 * 1000));

        winNotify.TileUpdateManager.createTileUpdaterForApplication().update(notification);
    }

    var notificationCount = 1;
    function notificationQueue() {
        var wideTile = tileContentFactory.createTileWideText01();
        wideTile.requireSquareContent = false;
        wideTile.textBody1.text = "Notification n. " + notificationCount;

        notificationCount += 1;

        var notification = wideTile.createNotification();

        winNotify.TileUpdateManager.createTileUpdaterForApplication().enableNotificationQueue(true);
        winNotify.TileUpdateManager.createTileUpdaterForApplication().update(notification);
    }

    function placeBadge() {
        // creazione di un badge numerico
        var badge = new NotificationsExtensions.BadgeContent.BadgeNumericNotificationContent(22);
        winNotify.BadgeUpdateManager
            .createBadgeUpdaterForApplication().update(badge.createNotification());

        // creazione di un badge con glifo
        var glyphBadge = new NotificationsExtensions.BadgeContent.BadgeGlyphNotificationContent(
            NotificationsExtensions.BadgeContent.GlyphValue.attention);
        winNotify.BadgeUpdateManager
            .createBadgeUpdaterForApplication().update(glyphBadge.createNotification());
    }

    var toastContentFactory = NotificationsExtensions.ToastContent.ToastContentFactory;
    function showToast() {
        var toastContent = toastContentFactory.createToastText01();

        toastContent.textBodyWrap.text = "Esempio di notifica toast";
        toastContent.audio.content = NotificationsExtensions.ToastContent.ToastAudioContent.default;
        toastContent.launch = "launchedByToast";

        var toast = new winNotify.ToastNotification(toastContent.getXml());

        winNotify.ToastNotificationManager.createToastNotifier()
            .show(toast);
    }

    function scheduleToast() {
        var toastContent = toastContentFactory.createToastText01();

        toastContent.textBodyWrap.text = "Esempio di notifica toast";
        toastContent.audio.content = NotificationsExtensions.ToastContent.ToastAudioContent.default;
        toastContent.launch = "launchedByToast";

        var currentDate = new Date();
        var scheduledDate = new Date(currentDate.getTime() + (60 * 1000));
        var toast = new winNotify.ScheduledToastNotification(toastContent.getXml(), scheduledDate);

        winNotify.ToastNotificationManager.createToastNotifier().addToSchedule(toast);
    }

    function requestChannel() {
        Windows.Networking.PushNotifications
          .PushNotificationChannelManager
          .createPushNotificationChannelForApplicationAsync()
          .done(function(channel) {
            txtChannel.value = channel.uri;
          });
    }

    app.start();
})();
