﻿using System;
using System.IO;
using System.Net;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Text;
using System.Web;

namespace PushSender
{
    class Program
    {
        public static void Main(string[] args)
        {
            new Program().Launch();
        }
        
        public void Launch()
        {
            string channelUri = "https://db3.notify.windows.com/?token=AgUAAABSexrWrz0%2b6gbW2sAKknbtXujKVPRR%2fDinrz3mQX1WP9Yex2Shs8bjJfT4gHC1OBo8XLXlQupCNOpaXyGU%2bRxL5eKzG0GEYhwoTDvBlKtwgKmJZ1yR39h6YG3FgxHDqsY%3d";

            string sid = "ms-app://s-1-15-2-2083882845-515968829-3462643377-2126588558-3632868686-444723508-369511708";
            string secret = "lob8pC8obUv0C49hTkkr0Q3B-N1sJ0kO";

            string xml = "<toast launch='launchedByToast'><visual version='1'><binding template='ToastText01'><text id='1'>Esempio di notifica toast da push</text></binding></visual></toast>";
            //xml = "<tile><visual version='1'><binding template='TileWideImageAndText01'><image id='1' src='http://gui.aspitalia.com/images/aspitalia/aspitalia.png'/><text id='1'>Windows 8 is awesome</text></binding><binding template='TileSquarePeekImageAndText03'><image id='1' src='Assets/Windows-8-logo.jpg'/><text id='1'>Windows 8 is</text><text id='2'>awesome!!</text></binding></visual></tile>";
            Console.WriteLine(this.PostToWns(secret, sid, channelUri, xml));
        }

        // Post to WNS
        public string PostToWns(string secret, string sid, string uri, string xml, string type = "wns/toast")
        {
            try
            {
                // You should cache this access token
                var accessToken = GetAccessToken(secret, sid);

                byte[] contentInBytes = Encoding.UTF8.GetBytes(xml);

                HttpWebRequest request = HttpWebRequest.Create(uri) as HttpWebRequest;
                request.Method = "POST";

                request.Headers.Add("X-WNS-Type", type);
                request.Headers.Add("Authorization", String.Format("Bearer {0}", accessToken.AccessToken));

                using (Stream requestStream = request.GetRequestStream())
                    requestStream.Write(contentInBytes, 0, contentInBytes.Length);

                using (HttpWebResponse webResponse = (HttpWebResponse)request.GetResponse())
                    return webResponse.StatusCode.ToString();
            }
            catch (WebException webException)
            {
                string exceptionDetails = webException.Response.Headers["WWW-Authenticate"] ?? string.Empty;
                if (exceptionDetails.Contains("Token expired"))
                {
                    GetAccessToken(secret, sid);

                    // Implement a maximum retry policy
                    return PostToWns(uri, xml, secret, sid, type);
                }
                else
                {
                    // Log the response
                    return "EXCEPTION: " + webException.Message;
                }
            }
            catch (Exception ex)
            {
                return "EXCEPTION: " + ex.Message;
            }
        }

        // Authorization
        [DataContract]
        public class OAuthToken
        {
            [DataMember(Name = "access_token")]
            public string AccessToken { get; set; }
            [DataMember(Name = "token_type")]
            public string TokenType { get; set; }
        }

        private OAuthToken GetOAuthTokenFromJson(string jsonString)
        {
            using (var ms = new MemoryStream(Encoding.Unicode.GetBytes(jsonString)))
            {
                var ser = new DataContractJsonSerializer(typeof(OAuthToken));
                var oAuthToken = (OAuthToken)ser.ReadObject(ms);
                return oAuthToken;
            }
        }

        protected OAuthToken GetAccessToken(string secret, string sid)
        {
            var urlEncodedSecret = HttpUtility.UrlEncode(secret);
            var urlEncodedSid = HttpUtility.UrlEncode(sid);

            var body = String.Format("grant_type=client_credentials&client_id={0}&client_secret={1}&scope=notify.windows.com",
                                     urlEncodedSid,
                                     urlEncodedSecret);

            string response;
            using (var client = new WebClient())
            {
                client.Headers.Add("Content-Type", "application/x-www-form-urlencoded");
                response = client.UploadString("https://login.live.com/accesstoken.srf", body);
            }
            return GetOAuthTokenFromJson(response);
        }    
    }
}
