﻿(function () {
    "use strict";

    var dom = Windows.Data.Xml.Dom;
    var not = Windows.UI.Notifications;

    // Includo degli script JavaScript
    importScripts("//Microsoft.WinJS.1.0/js/base.js");

    var backgroundTaskInstance = Windows.UI.WebUI.WebUIBackgroundTaskInstance.current;
    var promise;

    function onCanceled(cancelSender, cancelReason) {
        if (promise) {
            promise.operation.cancel();
        }
    }
    // Monitorizzo la richiesta di cancellazione
    backgroundTaskInstance.addEventListener("canceled", onCanceled);

    backgroundTaskInstance.progress = 10;

    // Simulo un'operazione asincrona
    promise = WinJS.Promise.timeout(2000);

    promise.then(function () {
        try {
            // Preparo il toast
            var content = not.ToastNotificationManager.getTemplateContent(not.ToastTemplateType.toastText01);
            content.selectSingleNode("//text").innerText = "Background task toast";

            var toast = new not.ToastNotification(content);
            // Mostro il toast
            not.ToastNotificationManager.createToastNotifier().show(toast);

            backgroundTaskInstance.progress = 100;

            // Imposto lo stato di successo del task
            backgroundTaskInstance.succeeded = true;
        }
        finally {
            // Chiudo l'esecuzione (da chiamare sempre)
            close();
        }
    }, function () {
        // Imposto lo stato di fallimento del task
        backgroundTaskInstance.succeeded = false;

        // Chiudo l'esecuzione (da chiamare sempre)
        close();
    });

})();