﻿// For an introduction to the Page Control template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232511
(function () {
    "use strict";

    var bt = Windows.ApplicationModel.Background;

    WinJS.UI.Pages.define("/pages/backgroundTask/backgroundTask.html", {
        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {

            // Chiedo di mettere l'applicazione sulla lock screen
            bt.BackgroundExecutionManager.requestAccessAsync();

            // Annullo tutti i task precedenti
            var iter = bt.BackgroundTaskRegistration.allTasks.first();
            var hascur = iter.hasCurrent;
            while (hascur) {
                iter.current.value.unregister(true);
                hascur = iter.moveNext();
            }

            // Definisco il trigger di sistema
            var trigger = new bt.SystemTrigger(bt.SystemTriggerType.internetAvailable, false);

            var builder = new bt.BackgroundTaskBuilder();
            // Nome descrittivo
            builder.name = "System task";
            // Nome completo del task, come nella dichiarazione
            builder.taskEntryPoint = "js\\task.js";
            builder.setTrigger(trigger);
            // Eventuale condizione
            builder.addCondition(new bt.SystemCondition(bt.SystemConditionType.userPresent));

            // Registro il task
            var registration = builder.register();
            description.textContent = registration.name + " schedulato";

            registration.addEventListener("completed", function (e) {
                try {
                    e.checkResult();

                    description.textContent = "Task completato";
                }
                catch (e) {
                    description.textContent = "Errore " + e.message;
                }
            });
            registration.addEventListener("progress", function (e) {
                description.textContent = "Progress " + e.progress;
            });
        },

        unload: function () {
            // TODO: Respond to navigations away from this page.
        },

        updateLayout: function (element, viewState, lastViewState) {
            /// <param name="element" domElement="true" />

            // TODO: Respond to changes in viewState.
        }
    });
})();
