﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Capitolo13.WebAPI.Models;

namespace Capitolo13.WebAPI.Controllers
{
	public class ValuesController : ApiController
	{
		static List<Customer> _customers = new List<Customer> {
			new Customer { Id = 1, Name = "Stefano Mostarda", Address = "Via del corso 1", City = "Roma", Country = "Italia", ZipCode = "00100" },
			new Customer { Id = 2, Name = "Daniele Bochicchio", Address = "Piazza venezia", City = "Milano", Country = "Italia", ZipCode = "00200" },
			new Customer { Id = 3, Name = "Marco Leoncini", Address = "Piazza del popolo", City = "Palermo", Country = "Italia", ZipCode = "00300" },
			new Customer { Id = 4, Name = "Crstian Civera", Address = "Piazza navona", City = "Bari", Country = "Italia", ZipCode = "00400" },
			new Customer { Id = 5, Name = "Alessio Leoncini", Address = "Piazza fontana di trevi", City = "Torino", Country = "Italia", ZipCode = "00500" },
			new Customer { Id = 6, Name = "Marco De Sanctis", Address = "Piazza di spagna", City = "Bologna", Country = "Italia", ZipCode = "00600" },
		};

// GET api/values
		public IEnumerable<Customer> Get()
		{
			return _customers;
		}

		// GET api/values/5
		public Customer Get(int id)
		{
			return _customers.First(c => c.Id == id);
		}

		// POST api/values
		public void Post(Customer customer)
		{
			_customers.Add(customer);
		}

		// PUT api/values/5
		public void Put(int id, Customer customer)
		{
			var localCustomer = _customers.First(c => c.Id == id);
			localCustomer.Address = customer.Address;
			localCustomer.City = customer.City;
			localCustomer.Country = customer.Country;
			localCustomer.Name = customer.Name;
			localCustomer.ZipCode = customer.ZipCode;
		}

		// DELETE api/values/5
		public void Delete(int id)
		{
			_customers.Remove(_customers.First(c => c.Id == id));
		}
	}
}